clear
clc

global temps Ir It Il Irl Itl Irt Asat etat_init vitesse_rotation altitude points_trace tau vitesse_angul_mini

global vitesse_angul_mini0 angle_mini_mod_fin rotation_initiale J jroue vitesseroue K_tumbling memoire switch1

global couple_max_roue moment_max_bobine instant_injection initpqrQ periode_pulse temps_action periode non_pulse pulse

global Ta Tu T champ B_prime temps_pulse derb_chapeau derivee_seconde B2_prime proportion KP_roue KD_roue proportion


% **************************************************************************************************************


%                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$
                     
                                    latitude_injection= 70;                                      % En degrs

%                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$


% ***************************  VALEURS DE REGLAGE  *************************


     couple_max_roue=4e-6;         % Nm   Valeur qui dclenche l'crtage proportionnel du couple roue

     moment_max_bobine=0.2;        % Am  Valeur qui dclenche l'crtage proportionnel du moment magntique                              

     vitesse_angul_mini=3e-3;      % Vitesse angulaire ( rd/s ) au dessous de laquelle on passe au mode fin

     angle_mini_mod_fin=5*pi/180; % Valeur du seuil des angles en dessous duquel la simulation s'arrte

    vitesse_angul_mini0=vitesse_angul_mini;  % Pour garder le souvenir de la valeur initiale


     points_trace=30000;           % Nombre de points du trac des courbes

     consigne_tangage=0;           % Consignes sur les angles
     consigne_roulis=0;
     consigne_lacet=0;

     pulse=0;                      % Choix d'une simulation non pulse ( fonctionnement continu des bobines )
                                   % et champ magntique rell
     proportion=0.6;               % Rpartition du poids des 2 rgulations en parallle dans le mode Bpoint        

% -------------------------- Rglages du creneau  ---------------------
% Le creneau est une fonction priodique prenant les valeurs 1 ou 0
%	1 durant le temps d'action de la rgulation

%	0 durant le temps de mesure du magntomtre qui ne doit pas tre perturb
%	par des courants ou champs parasites.

%    *************************    CALCULS D'INITIALISATION DU PULSE  **************************

% Donnes caractristiques du pulse

Ta=1;         % Temps d'arrt des sources polluantes en champ magntique

T=10;         % Priode du pulse,Dure totale du cycle,en secondes

periode=T;                 % 
temps_action=T-Ta;             % Temps durant lequel la rgulation est active

pulse_lineaire=1;  % Pour un champ magntique crneau ( constant entre 2 mesures )
                   % La valeur 1 fait passer au mode linaire entre 2 mesures

% ***************************  FIN DES REGLAGES DE DONNEES  **********************

proportion=0.6;

% ******************** VALEURS DE REGLAGE DES CONTROLES *************************

% Contrle supplmentaire en tangage, parallle au dtumbling

KR=0.2;                     % Gain en rappel sur l'angle tangage

KV=20;                       % Gain en vitesse sur la vitesse tangage

G_supplement=1;             % Gain sur la chane


%***************** DONNEES PID ROULIS *************************
 
 K_PID_ROULIS=3.2e-6;   %   Gain proportionnel
 F_PID_ROULIS=12.8e-5*2;     %   Gain amortissement drive
 I_PID_ROULIS=1e-8;     %   Gain intgrateur
 
 gain_roulis=62500;

% ***************** DONNEES PID LACET **************************
 
 K_PID_LACET=1.375e-6;   %   Gain proportionnel
 F_PID_LACET=3.95e-4;     %   Gain amortissement drive
 I_PID_LACET=2e-8;     %   Gain intgrateur
 gain_lacet=62500;

%  ***************** DONNEES PID TANGAGE ********************
 
 K_PID_TANGAGE=3.6e-6;      %   Gain proportionnel
 F_PID_TANGAGE=36e-5;    %   Gain amortissement drive

 I_PID_TANGAGE=1e10;       %   Gain intgrateur non utilis

 gain_tangage=82500;


% **************  FIN DES VALEURS DES REGLAGES DE CONTROLE  *************************

%  ***************** DONNEES RAPPEL ROUE SUPPLEMENTAIRE ********************

KP_roue=3e-6;
KD_roue=-3e-6;


% *******************************************************************************
% *********************  INITIALISATIONS DES SIMULATIONS  ***********************

%   **********  VALEURS INITIALES EN VITESSES EN TUMBLING INITIAL *************

% Initialisation en vitesses (rd/s)

v_roulis0=0.06;
v_tangage0=0.05;
v_lacet0=0.01;

% ****************  Initialisation en position (rd) *********

roulis0=0.1;
tangage0=-0.1;
lacet0=0.05;

% *******************************************************************************


switch1=1;                    % Initialise le switch calcul en cours de simulation,
                              % sa valeur doit basculer  0 vers 1500 1700 secondes

memoire=1;
                              % Le changement de valeur de K_tumbling s'opre lorsque
                              % les vitesses passent sous le seuil fix par vitesse_angul_mini
                              % par dfaut  1.5e-3 rd/s
K_tumbling=1;                
                              % Indicateur de tumbling, quand K_tumbling passe  0
                              % la rgulation bascule en mode acquisition grossire
                              % puis continue sur le mode pointage fin


rotation_initiale=0;          % Vitesse angulaire initiale de la roue

vitesseroue=0;                % Initialisation de la vitesse de la roue


% *************  Gain de la matrice de gain pour la drive de B *******

  tau=200; % Constante de temps


% Ce fichier initialise la simulation casaasat.m ou regdesat.m ou acqseul1.m ou totale0

% ****************  Matrice d''inertie satellite et roue ******************

% Ir=32e-3;It=36e-3;Il=32e-3;Irt=5.8e-5*0;Irl=3e-4*0;Itl=4e-3*0;   % Valeurs pour simulation
                                                                   % de Poinsot symtrique

Ir=32e-3;It=36e-3;Il=22e-3;Irt=5.8e-5;Irl=3e-4;Itl=4e-3;   % Valeurs pour le nanosatellite rel
                                                           % ou Poinsot gnral

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

% Inertie de la roue

jroue=3.2e-5;

J=3.2e-5;

% *****************  Caractristiques de l'orbite du satellite ***********

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);
				% pulsation orbitale en rd/s
inclinaison=98.7*pi/180;

periode_orbitale=2*pi/vitesse_rotation;

instant_injection=asin(sin(latitude_injection*pi/180)/sin(inclinaison))/vitesse_rotation;
 
instant_injection=fix(instant_injection);              % Instant injection calcul  1 seconde prs
                                                       % aprs survol quateur suppos  t=0 seconde

% ***************** DONNEES PERTURBATIONS********************

% ******************** Donnes annexes*************************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;

% **********************************************************************

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

% Q=[qt00 qt10 qt20 qt30], %  ********* devrait avoir une norme 1

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

% normQ=norm(Q),% ******** vrifi *******

% energie=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]',  %  ********  Energie devrait rester constante

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; 


% Le fonctionnement du diagramme b_estime.m a besoin des valeurs initiales du champ magntique
% au dbut du calcul, quel que soit ce dbut, pas ncessairement 0
% On utilise donc :
%	Le temps d'injection
% 	La position initiale

% Pour calculer d'abord le champ orbital, puis le champ satellite initial

%  Champ orbital

B_orbital0=champmgn(instant_injection);

B_sat0=inv(Pmat)*B_orbital0;

% Drive initiale du champ, estime comme partie essentielle due  la rotation (dB/dt=omega vect B )

derB0(1)=vq0*B_sat0(3)-vr0*B_sat0(2);                % inutile
derB0(2)=vr0*B_sat0(1)-vp0*B_sat0(3);               % inutile 
derB0(3)=vp0*B_sat0(2)-vq0*B_sat0(1);               % inutile

% Estimation de la drive au dpart sur 1 s, pour viter une drive infinie

B_orbital1=champmgn(instant_injection+1);

B_prime=inv(Pmat)*(champmgn(instant_injection+1)-champmgn(instant_injection));


% Ces premires valeurs sont stockes dans 2 fichiers


champ=B_sat0;

save champ.mat champ;

temps_pulse(1)=instant_injection;


derb_chapeau=[derB0(1); derB0(2); derB0(3)]';
save derbchap.mat derb_chapeau;

B2_prime=[derB0(1) derB0(2) derB0(3)]';


derB0=[derB0(1) derB0(2) derB0(3)]';
B2_prime=[B2_prime derB0];
save der2B.mat B2_prime;

derivee_seconde=[0 0 0]';

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat
end









